
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP FUNCTION F_KPI_CDR_GETCOLOR;

CREATE OR REPLACE FUNCTION F_KPI_CDR_GETCOLOR (
	V_KPI_ID IN NUMBER,
	V_VALUE IN NUMBER DEFAULT NULL
  )
RETURN NUMBER IS
  V_KPI_VALUE NUMBER(15,4);
  V_GREEN_MIN NUMBER(15,4);
  V_GREEN_MAX NUMBER(15,4);
  V_ORANGE_MIN NUMBER(15,4);
  V_ORANGE_MAX NUMBER(15,4);
  V_RED_MIN NUMBER(15,4);
  V_RED_MAX NUMBER(15,4);
  V_COLOR NUMBER(1);
BEGIN
-- 1=GREEN
-- 2=ORANGE
-- 3=RED

  V_COLOR:=1;

  IF (V_VALUE IS NULL) THEN
	  SELECT CALCULATED_VALUE INTO V_KPI_VALUE
	  FROM KPI_CALCULATED_VALUES
	  WHERE KPI_ID=V_KPI_ID;
  ELSE
	V_KPI_VALUE:=V_VALUE;
  END IF;

  SELECT GREEN_MIN,  GREEN_MAX,
	 ORANGE_MIN, ORANGE_MAX,
	 RED_MIN,    RED_MAX
  INTO   V_GREEN_MIN,  V_GREEN_MAX,
	 V_ORANGE_MIN, V_ORANGE_MAX,
	 V_RED_MIN,    V_RED_MAX
  FROM REF_KPI_DEFINITION
  WHERE KPI_ID=V_KPI_ID;


  IF (V_GREEN_MAX IS NULL) THEN 
	V_GREEN_MAX:=V_KPI_VALUE;
  END IF;
  IF (V_ORANGE_MIN IS NULL) THEN
	V_ORANGE_MIN:=V_GREEN_MAX;
  END IF;
  IF (V_ORANGE_MAX IS NULL) THEN
	V_ORANGE_MAX:=V_ORANGE_MIN;
  END IF;
  IF (V_RED_MIN IS NULL) THEN
	V_RED_MIN:=V_ORANGE_MAX;
  END IF;
  IF (V_RED_MAX IS NULL) THEN
	IF (V_KPI_VALUE > V_RED_MIN) THEN
		V_RED_MAX:=V_KPI_VALUE;
	ELSE
		V_RED_MAX:=(2*V_ORANGE_MAX)-V_ORANGE_MIN;
	END IF;
  END IF;

  IF ((V_KPI_VALUE>= V_GREEN_min) AND (V_KPI_VALUE< V_GREEN_MAX)) THEN
	V_COLOR:=1;
  END IF;
  IF ((V_KPI_VALUE>= V_ORANGE_MIN) AND (V_KPI_VALUE< V_ORANGE_MAX)) THEN
	V_COLOR:=2;
  END IF;
  IF ((V_KPI_VALUE>= V_RED_MIN) AND (V_KPI_VALUE<= V_RED_MAX)) THEN
	V_COLOR:=3;
  END IF;

  RETURN V_COLOR;

END F_KPI_CDR_GETCOLOR;
/

