
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP FUNCTION F_KPI_SDR_SUBSCRIBERS_PERCENT;

CREATE OR REPLACE FUNCTION F_KPI_SDR_SUBSCRIBERS_PERCENT (
 	V_RECONCILIATION_ID IN NUMBER,
	V_WHERE_CLAUSE_1 IN VARCHAR2,
	V_WHERE_CLAUSE_2 IN VARCHAR2
  )
RETURN TYPE_KPI_RESULT_ARRAY IS
  V_COUNT_1 NUMBER(20);
  V_COUNT_2 NUMBER(20);
  V_PERCENT NUMBER(20,4);
  V_TABLE VARCHAR2(35);
  V_TABLE_A VARCHAR2(35);
  V_TABLE_B VARCHAR2(35);
  V_KEY_A VARCHAR2(35);
  V_KEY_B VARCHAR2(35);
  V_LOAD_A NUMBER(3);
  V_LOAD_B NUMBER(3);
  COMMAND_LINE VARCHAR2(500);
  TYPE T_DYN_CURSOR IS REF CURSOR;
  C1 T_DYN_CURSOR;
  KPI_RESULT_ARRAY TYPE_KPI_RESULT_ARRAY:=TYPE_KPI_RESULT_ARRAY();
BEGIN
  V_COUNT_1:=0;
  V_COUNT_2:=0;
  V_PERCENT:=0;

  SELECT X.RESULT_TABLE, A.LAST_LOAD_NB, B.LAST_LOAD_NB, A.TABLE_NAME, B.TABLE_NAME,
	 X.KEY_TABLE_A, X.KEY_TABLE_B
  INTO V_TABLE, V_LOAD_A, V_LOAD_B, V_TABLE_A, V_TABLE_B, V_KEY_A, V_KEY_B
  FROM REF_SDR_RECONCILIATIONS X, REF_SDR_PLATFORMS A, REF_SDR_PLATFORMS B
  WHERE RECONCILIATION_ID = V_RECONCILIATION_ID
  AND X.PLATFORM_ID_A=A.PLATFORM_ID 
  AND X.PLATFORM_ID_B=B.PLATFORM_ID(+);

  COMMAND_LINE:='SELECT COUNT(*) FROM ' || V_TABLE;
  COMMAND_LINE:=COMMAND_LINE || ' WHERE ' || V_KEY_A || '=' || TO_CHAR(V_LOAD_A);
  IF (V_TABLE_B IS NOT NULL) THEN
	  COMMAND_LINE:=COMMAND_LINE || ' AND '   || V_KEY_B || '=' || TO_CHAR(V_LOAD_B);
  END IF;
  COMMAND_LINE:=COMMAND_LINE || ' AND ' || V_WHERE_CLAUSE_1;

  OPEN C1 FOR COMMAND_LINE;
  LOOP
      FETCH C1 INTO V_COUNT_1;
      EXIT WHEN C1%NOTFOUND;
  END LOOP;
  CLOSE C1;

  COMMAND_LINE:='SELECT COUNT(*) FROM ' || V_TABLE;
  COMMAND_LINE:=COMMAND_LINE || ' WHERE ' || V_TABLE_A || '_LOAD_NB=' || TO_CHAR(V_LOAD_A);
  IF (V_TABLE_B IS NOT NULL) THEN
	  COMMAND_LINE:=COMMAND_LINE || ' AND '   || V_TABLE_B || '_LOAD_NB=' || TO_CHAR(V_LOAD_B);
  END IF;
  COMMAND_LINE:=COMMAND_LINE || ' AND ' || V_WHERE_CLAUSE_2;

  OPEN C1 FOR COMMAND_LINE;
  LOOP
      FETCH C1 INTO V_COUNT_2;
      EXIT WHEN C1%NOTFOUND;
  END LOOP;
  CLOSE C1;

  IF (V_COUNT_2 > 0) THEN
	V_PERCENT:=V_COUNT_1/V_COUNT_2;
  ELSE
	IF (V_COUNT_1 > 0) THEN
	    V_PERCENT:=1;
	END IF;
  END IF;

  KPI_RESULT_ARRAY.EXTEND;
  KPI_RESULT_ARRAY(1):=V_PERCENT;

  KPI_RESULT_ARRAY.EXTEND;
  KPI_RESULT_ARRAY(2):=V_LOAD_A;

  KPI_RESULT_ARRAY.EXTEND;
  IF (V_TABLE_B IS NOT NULL) THEN
  	KPI_RESULT_ARRAY(3):=V_LOAD_B;
  ELSE
  	KPI_RESULT_ARRAY(3):=-1;
  END IF;

  RETURN KPI_RESULT_ARRAY;

END F_KPI_SDR_SUBSCRIBERS_PERCENT;
/

