
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP PROCEDURE P_CDR_ST_OTHER_SOURCE;

CREATE OR REPLACE PROCEDURE P_CDR_ST_OTHER_SOURCE IS
  TYPE T_ST_LIST IS VARRAY(9) OF NUMBER(3);
  ST_LIST T_ST_LIST;
  CURSOR C1 IS SELECT *
	FROM LOAD_CDR_OTHER_SOURCE
	FOR UPDATE;
  CURSOR C2 IS SELECT CONTROL_POINT_ID
	FROM REF_CDR_CONTROL_POINTS
	WHERE TABLE_NAME='OTHER_SOURCE';
  LIST_INDEX NUMBER(2);
  FILTERED NUMBER(1);
  V_VALUE NUMBER(10,3);
  V_CP_ID NUMBER(3);
BEGIN

  ST_LIST:=T_ST_LIST(NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
  OPEN C2;
  FETCH C2 INTO V_CP_ID;
  CLOSE C2;

  FOR C IN C1 LOOP

    FOR X IN 1..9 LOOP
	ST_LIST (X):=NULL;
    END LOOP;

    LIST_INDEX:=1;
    FILTERED:=0;
    V_VALUE:=0;

    -- 1=ALL (EVERY CDR IS CLASSIFIED AS 'ALL' SERVICE TYPE)
    ST_LIST(LIST_INDEX):=1;
    LIST_INDEX:=LIST_INDEX+1;


    -- 2=Service-Type to classify the CDR (MO, MT, SMS, etc.)
    -- Define here your business rule
	IF (
		C.FIELD_1 = 'ValueForServiceType2'
           --   AND ...
	    ) 
   	THEN
	    ST_LIST(LIST_INDEX):=2;  -- 2=the Id of the Service-Type
	    LIST_INDEX:=LIST_INDEX+1;
	    FILTERED:=1;
	    V_VALUE:=F_CDR_RATING(V_CP_ID, 2, C.FIELD_3); -- Assuming Field_3 is required to calculate the estimated CDR value (i.e. contains CDR duration)

       END IF;

    -- 3=Service-Type to classify the CDR (MO, MT, SMS, etc.)
    -- Define here your business rule
	IF (
		C.FIELD_1 = 'ValueForServiceType3'
           --   AND ...
	    ) 
   	THEN
	    ST_LIST(LIST_INDEX):=3; 
	    LIST_INDEX:=LIST_INDEX+1;
	    FILTERED:=1;
	    V_VALUE:=F_CDR_RATING(V_CP_ID, 3, C.FIELD_3); -- Assuming Field_3 is required to calculate the estimated CDR value (i.e. contains CDR duration)

       END IF;

    -- Etc.

    UPDATE LOAD_CDR_OTHER_SOURCE
	SET ST_ID_1=ST_LIST(1),
	    ST_ID_2=ST_LIST(2),
	    ST_ID_3=ST_LIST(3),
	    ST_ID_4=ST_LIST(4),
	    ST_ID_5=ST_LIST(5),
	    ST_ID_6=ST_LIST(6),
	    ST_ID_7=ST_LIST(7),
	    ST_ID_8=ST_LIST(8),
	    ST_ID_9=ST_LIST(9),
	    DURATION=C.FIELD_3, -- whatever field contains CDR duration
	    VALUE=V_VALUE
	WHERE CURRENT OF C1;

  END LOOP;

END;
/