
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP FUNCTION F_CDR_RATING;

CREATE OR REPLACE FUNCTION F_CDR_RATING (
	V_CONTROL_POINT_ID NUMBER,
	V_SERVICE_TYPE_ID  NUMBER,
	V_DURATION	   NUMBER )
RETURN NUMBER
IS

  CURSOR C1 (V_CP_ID NUMBER, V_ST_ID NUMBER) IS 
	SELECT RATE_PER_MIN, RATE_PER_EVENT
	FROM REF_CDR_ST_MATRIX
	WHERE CONTROL_POINT_ID=V_CP_ID
	AND SERVICE_TYPE_ID=V_ST_ID;

  V_RATE_PER_MIN NUMBER(6,3);
  V_RATE_PER_EVENT NUMBER(6,3);
  V_CALCULATED_VALUE NUMBER(10,3);

BEGIN

  V_CALCULATED_VALUE:=0;

  IF (V_DURATION IS NULL) THEN
	V_CALCULATED_VALUE:=0;
  ELSE

	  OPEN C1(V_CONTROL_POINT_ID, V_SERVICE_TYPE_ID);
	  FETCH C1 INTO V_RATE_PER_MIN, V_RATE_PER_EVENT;
	  IF (C1%NOTFOUND) THEN
		V_RATE_PER_EVENT:=0;
		V_RATE_PER_MIN:=0;
	  END IF;
	  CLOSE C1;

	  IF (V_RATE_PER_EVENT > 0) THEN
		V_CALCULATED_VALUE:=V_RATE_PER_EVENT;
	  ELSE
		V_CALCULATED_VALUE:=V_RATE_PER_MIN*(V_DURATION/60);
	  END IF;
  END IF;

RETURN 	V_CALCULATED_VALUE;

END F_CDR_RATING;
/
