
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP PROCEDURE P_CDR_CALC_SUM;

CREATE OR REPLACE PROCEDURE P_CDR_CALC_SUM (
	V_TABLE      IN VARCHAR2,
	V_DATE_FIELD IN VARCHAR2)
IS
  COMMAND_LINE VARCHAR2(500);
  CURSOR C1 (V_CP_ID NUMBER) IS 
	SELECT a.SERVICE_TYPE_ID, b.INTERVAL
	FROM REF_CDR_ST_MATRIX a, REF_CDR_SERVICE_TYPES b
	WHERE a.SERVICE_TYPE_ID=b.SERVICE_TYPE_ID
	AND CONTROL_POINT_ID=V_CP_ID;
  TYPE T_DYN_CURSOR IS REF CURSOR;
  C2 T_DYN_CURSOR;
  CURSOR C3 (PARAM_TABLE VARCHAR2) IS 
	SELECT CONTROL_POINT_ID
	FROM REF_CDR_CONTROL_POINTS
	WHERE TABLE_NAME=PARAM_TABLE;
  V_DATE DATE;
  V_COUNT NUMBER(30); 
  V_DURATION NUMBER(30);
  V_VALUE NUMBER(30);
  CDR_TABLE VARCHAR2(30);
  V_CONTROL_POINT_ID NUMBER(3);
  V_INTERVAL VARCHAR2(5);
BEGIN
  OPEN C3(V_TABLE);
  FETCH C3 INTO V_CONTROL_POINT_ID;
  CLOSE C3;

  V_CONTROL_POINT_ID_2:=0;
  CDR_TABLE := V_TABLE;

  FOR C IN C1 (V_CONTROL_POINT_ID) LOOP

    V_INTERVAL:='HH24';

    IF (C.INTERVAL = 'D') THEN
	V_INTERVAL:='DD';
    END IF;
        
    COMMAND_LINE:='SELECT TRUNC(' || V_DATE_FIELD || ', ''' || V_INTERVAL || '''), count(*), sum(DURATION), sum(VALUE) ';
    COMMAND_LINE:=COMMAND_LINE || ' FROM LOAD_CDR_' || CDR_TABLE;
    COMMAND_LINE:=COMMAND_LINE || ' WHERE ST_ID_1=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_2=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_3=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_4=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_5=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_6=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_7=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_8=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' OR ST_ID_9=' || TO_CHAR(C.SERVICE_TYPE_ID, '000');
    COMMAND_LINE:=COMMAND_LINE || ' GROUP BY TRUNC(' || V_DATE_FIELD || ', ''' || V_INTERVAL || ''')';

    OPEN C2 FOR COMMAND_LINE;
    LOOP

      FETCH C2 INTO V_DATE, V_COUNT, V_DURATION, V_VALUE;
      EXIT WHEN C2%NOTFOUND;

      IF (V_DATE < (SYSDATE+1)) THEN

	      UPDATE CDR_ALL_SUMMARY
	      SET COUNT=COUNT+V_COUNT,
		  DURATION=DURATION+V_DURATION,
		  VALUE=VALUE+V_VALUE
	      WHERE CONTROL_POINT_ID = V_CONTROL_POINT_ID
	      AND TRANS_DT=V_DATE
	      AND SERVICE_TYPE_ID=C.SERVICE_TYPE_ID;

      END IF;

    END LOOP;
    CLOSE C2;
  END LOOP;

END;
/