
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP PROCEDURE P_CDR_EXECUTE_JOB_COMPARE;

CREATE OR REPLACE PROCEDURE P_CDR_EXECUTE_JOB_COMPARE(
	JOB_ID IN NUMBER
)
IS
  COMMAND_LINE VARCHAR2(3000);
  CURSOR C1 (PARAM_TABLE VARCHAR2) IS 
	SELECT CONTROL_POINT_ID
	FROM REF_CDR_CONTROL_POINTS
	WHERE TABLE_NAME=PARAM_TABLE;
  CURSOR C2 (PARAM_JOB NUMBER) IS
	SELECT TABLE_A, TABLE_B, TRANS_DT_MIN, TRANS_DT_MAX, SERVICE_TYPE_ID, TOLERANCE
	FROM RESULT_CDR_SUMMARY
	WHERE JOB_ID=PARAM_JOB;
  V_CONTROL_POINT_ID NUMBER(3);
  V_TABLE_A VARCHAR2(30);
  V_TABLE_B VARCHAR2(30);
  V_TRANS_DT_MIN DATE;
  V_TRANS_DT_MAX DATE;
  V_DATE_FLD_A VARCHAR2(30);
  V_DATE_FLD_B VARCHAR2(30);
  V_POINT_ORIGIN_FLD_A VARCHAR2(30);
  V_POINT_ORIGIN_FLD_B VARCHAR2(30);
  V_POINT_TARGET_FLD_A VARCHAR2(30);
  V_POINT_TARGET_FLD_B VARCHAR2(30);
  V_TOLERANCE NUMBER(2);
  V_SERVICE_TYPE_ID NUMBER(3);
BEGIN

  OPEN C2(JOB_ID);
  FETCH C2 INTO V_TABLE_A, V_TABLE_B, V_TRANS_DT_MIN, V_TRANS_DT_MAX, V_SERVICE_TYPE_ID, V_TOLERANCE;
  CLOSE C2;

  IF (V_TABLE_A = 'SAMPLE_SOURCE') THEN
	V_DATE_FLD_A :='TRANSACTION_DATE';
	V_POINT_ORIGIN_FLD_A := 'FIELD_1';
  END IF;
  IF (V_TABLE_B = 'OTHER_SOURCE') THEN
	V_DATE_FLD_B :='TRANSACTION_DATE';
	V_POINT_ORIGIN_FLD_B := 'FIELD_1';
  END IF;

  COMMAND_LINE:='INSERT INTO RESULT_CDR_MATCH (JOB_ID, ROW_ID_A, ROW_ID_B) ';
  COMMAND_LINE:=COMMAND_LINE || 'SELECT  ' || TO_CHAR(JOB_ID) || ', A.ROWID, B.ROWID ';
  COMMAND_LINE:=COMMAND_LINE || 'FROM CDR_' || V_TABLE_A || ' A, ';
  COMMAND_LINE:=COMMAND_LINE || 'CDR_' || V_TABLE_B || ' B ';
  COMMAND_LINE:=COMMAND_LINE || 'WHERE ';
  COMMAND_LINE:=COMMAND_LINE || '((A.' || V_DATE_FLD_A || '=B.' || V_DATE_FLD_B || ')';
  COMMAND_LINE:=COMMAND_LINE || ' OR (ABS(A.' || V_DATE_FLD_A || '-B.' || V_DATE_FLD_B || ')*24*60*60 <=' || TO_CHAR(V_TOLERANCE) || '))';

  IF (V_POINT_ORIGIN_FLD_A IS NOT NULL) THEN
	  COMMAND_LINE:=COMMAND_LINE || ' AND A.' || V_POINT_ORIGIN_FLD_A;
	  COMMAND_LINE:=COMMAND_LINE || '=B.' || V_POINT_ORIGIN_FLD_B;
  END IF;
  IF (V_POINT_TARGET_FLD_A IS NOT NULL) THEN
	  COMMAND_LINE:=COMMAND_LINE || ' AND A.' || V_POINT_TARGET_FLD_A;
	  COMMAND_LINE:=COMMAND_LINE || '=B.' || V_POINT_TARGET_FLD_B;
  END IF;
  COMMAND_LINE:=COMMAND_LINE || ' AND   A.' || V_DATE_FLD_A || ' BETWEEN TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MIN, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
  COMMAND_LINE:=COMMAND_LINE || 'AND TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MAX, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
  COMMAND_LINE:=COMMAND_LINE || ' AND (';
  COMMAND_LINE:=COMMAND_LINE || '    A.ST_ID_1=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_2=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_3=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_4=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_5=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_6=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_7=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_8=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_9=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' )';
  COMMAND_LINE:=COMMAND_LINE || ' AND (';
  COMMAND_LINE:=COMMAND_LINE || '    B.ST_ID_1=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_2=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_3=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_4=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_5=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_6=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_7=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_8=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_9=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' )';


  EXECUTE IMMEDIATE COMMAND_LINE;

  COMMAND_LINE:='UPDATE RESULT_CDR_SUMMARY SET IN_A_AND_B = (SELECT COUNT(*) FROM RESULT_CDR_MATCH ';
  COMMAND_LINE:= COMMAND_LINE || 'WHERE JOB_ID=' || TO_CHAR(JOB_ID) || ') WHERE JOB_ID=' || TO_CHAR(JOB_ID);

  EXECUTE IMMEDIATE COMMAND_LINE;

  OPEN C1(V_TABLE_A);
    FETCH C1 INTO V_CONTROL_POINT_ID;
  CLOSE C1;

  COMMAND_LINE:='INSERT INTO RESULT_CDR_MISMATCH (JOB_ID, CONTROL_POINT_ID, ROW_ID) ';
  COMMAND_LINE:=COMMAND_LINE || 'SELECT  ' || TO_CHAR(JOB_ID) || ', ' || TO_CHAR(V_CONTROL_POINT_ID) || ', A.ROWID ';
  COMMAND_LINE:=COMMAND_LINE || 'FROM CDR_' || V_TABLE_A || ' A ';
  COMMAND_LINE:=COMMAND_LINE || ' WHERE   A.' || V_DATE_FLD_A || ' BETWEEN TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MIN, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
  COMMAND_LINE:=COMMAND_LINE || 'AND TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MAX, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
  COMMAND_LINE:=COMMAND_LINE || 'AND NOT EXISTS (SELECT X.ROW_ID_A FROM RESULT_CDR_MATCH X ';
  COMMAND_LINE:=COMMAND_LINE || 'WHERE X.ROW_ID_A=A.ROWID AND JOB_ID=' || TO_CHAR(JOB_ID) || ')';
  COMMAND_LINE:=COMMAND_LINE || ' AND (';
  COMMAND_LINE:=COMMAND_LINE || '    A.ST_ID_1=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_2=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_3=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_4=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_5=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_6=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_7=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_8=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR A.ST_ID_9=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' )';


  EXECUTE IMMEDIATE COMMAND_LINE;

  COMMAND_LINE:='UPDATE RESULT_CDR_SUMMARY SET IN_A_NOT_B = (SELECT COUNT(*) FROM RESULT_CDR_MISMATCH ';
  COMMAND_LINE:=COMMAND_LINE || 'WHERE CONTROL_POINT_ID=' || TO_CHAR(V_CONTROL_POINT_ID);
  COMMAND_LINE:=COMMAND_LINE || ' AND JOB_ID=' || TO_CHAR(JOB_ID) || ') WHERE JOB_ID=' || TO_CHAR(JOB_ID);

  EXECUTE IMMEDIATE COMMAND_LINE;

  OPEN C1(V_TABLE_B);
    FETCH C1 INTO V_CONTROL_POINT_ID;
  CLOSE C1;

  COMMAND_LINE:='INSERT INTO RESULT_CDR_MISMATCH (JOB_ID, CONTROL_POINT_ID, ROW_ID) ';
  COMMAND_LINE:=COMMAND_LINE || 'SELECT  ' || TO_CHAR(JOB_ID) || ', ' || TO_CHAR(V_CONTROL_POINT_ID) || ', B.ROWID ';
  COMMAND_LINE:=COMMAND_LINE || 'FROM CDR_' || V_TABLE_B || ' B ';
  COMMAND_LINE:=COMMAND_LINE || ' WHERE   B.' || V_DATE_FLD_B || ' BETWEEN TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MIN, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
  COMMAND_LINE:=COMMAND_LINE || 'AND TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MAX, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
  COMMAND_LINE:=COMMAND_LINE || 'AND NOT EXISTS (SELECT X.ROW_ID_B FROM RESULT_CDR_MATCH X ';
  COMMAND_LINE:=COMMAND_LINE || 'WHERE X.ROW_ID_B=B.ROWID AND JOB_ID=' || TO_CHAR(JOB_ID) || ')';
  COMMAND_LINE:=COMMAND_LINE || ' AND (';
  COMMAND_LINE:=COMMAND_LINE || '    B.ST_ID_1=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_2=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_3=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_4=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_5=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_6=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_7=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_8=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' OR B.ST_ID_9=' || V_SERVICE_TYPE_ID ;
  COMMAND_LINE:=COMMAND_LINE || ' )';

  EXECUTE IMMEDIATE COMMAND_LINE;

  COMMAND_LINE:='UPDATE RESULT_CDR_SUMMARY SET IN_B_NOT_A = (SELECT COUNT(*) FROM RESULT_CDR_MISMATCH ';
  COMMAND_LINE:=COMMAND_LINE || 'WHERE CONTROL_POINT_ID=' || TO_CHAR(V_CONTROL_POINT_ID);
  COMMAND_LINE:=COMMAND_LINE || ' AND JOB_ID=' || TO_CHAR(JOB_ID) || ') WHERE JOB_ID=' || TO_CHAR(JOB_ID);

  EXECUTE IMMEDIATE COMMAND_LINE;

  COMMAND_LINE:='UPDATE RESULT_CDR_SUMMARY SET JOB_STATUS=2 WHERE JOB_ID=' || TO_CHAR(JOB_ID);

  EXECUTE IMMEDIATE COMMAND_LINE;


  COMMIT;

END;
/


